import "./style.css";
import { computed as G, reactive as $, onActivated as j, onDeactivated as J, watch as q, ref as K, resolveComponent as p, openBlock as Q, createBlock as W, withCtx as N, createVNode as h, createElementVNode as f, normalizeClass as X, toDisplayString as Z, withDirectives as M, vShow as E } from "vue";
import { Grid as ee, GridColumn as oe } from "@opentiny/vue";
import { PluginPanel as te, SvgButton as ne } from "@opentiny/tiny-engine-common";
import { constants as re } from "@opentiny/tiny-engine-utils";
import { iconEyeopen as ce, iconEyeclose as se, IconChevronDown as ae } from "@opentiny/vue-icon";
import { useCanvas as y, useMaterial as ie, useLayout as F, useMessage as le } from "@opentiny/tiny-engine-meta-register";
import { extend as de } from "@opentiny/vue-renderless/common/object";
import { typeOf as pe } from "@opentiny/vue-renderless/common/type";
const ge = (i, t) => {
  const d = i.__vccOpts || i;
  for (const [n, g] of t)
    d[n] = g;
  return d;
}, { PAGE_STATUS: O } = re, ue = {
  components: {
    TinyGrid: ee,
    TinyGridColumn: oe,
    PluginPanel: te,
    SvgButton: ne,
    IconEyeopen: ce(),
    IconEyeclose: se()
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(i) {
    const { pageState: t, getInstance: d } = y(), { getMaterial: n } = ie(), { PLUGIN_NAME: g } = F(), T = G(() => {
      var e;
      return (e = i.fixedPanels) == null ? void 0 : e.includes(g.OutlineTree);
    }), u = (e) => {
      const c = (a) => (a.forEach((s) => {
        s.show = t.nodesStatus[s.id] !== !1, s.showEye = !s.show;
        const S = s.children;
        pe(S) !== "array" ? delete s.children : s.children.length && c(s.children);
      }), a);
      return [{ ...c([de(!0, {}, e)])[0], componentName: "body" }];
    }, o = $({
      pageSchema: [],
      expandAll: !0,
      initSchema: [],
      isLock: G(
        () => ![O.Occupy, O.Guest].includes(F().layoutState.pageStatus.state)
      ),
      dragState: {
        allowDrop: !0,
        dragSchema: null,
        hoverVm: null,
        currentVm: null,
        parentNode: null,
        indicator: !0
      }
    }), { subscribe: x, unsubscribe: A } = le();
    j(() => {
      o.pageSchema = u(t.pageSchema), x({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({ operation: e }) => {
          (e == null ? void 0 : e.type) !== "changeProps" && (o.pageSchema = u(t.pageSchema));
        }
      });
    }), J(() => {
      A({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }), q(
      () => t.currentSchema,
      () => {
        const { getSchema: e } = y();
        o.pageSchema = u(e());
      }
    );
    const I = () => {
      o.expandAll = !o.expandAll;
    }, C = (e) => {
      e.show = !e.show, t.nodesStatus[e.id] = e.show;
      const { getRenderer: c, clearSelect: a } = y().canvasApi.value;
      c().setCondition(e.id, e.show), a();
    }, r = (e) => e.componentName ? n(e.componentName).icon || "IconAssociation" : void 0, _ = (e) => {
      if (o.isLock)
        return;
      const { hoverNode: c } = y().canvasApi.value;
      c(e.id), e.showEye = !0;
    }, w = (e) => {
      e && !e.show || (e.showEye = !1);
    }, m = (e) => {
      if (o.isLock)
        return;
      const { selectNode: c } = y().canvasApi.value;
      c(e == null ? void 0 : e.id, "clickTree");
    }, R = K(null), V = () => {
    }, B = ({ row: e }) => {
      var a;
      return "nav-tree " + (((a = t == null ? void 0 : t.currentSchema) == null ? void 0 : a.id) === e.id ? "high-light-node" : "");
    }, U = (e, c) => {
      var P;
      e.dragged.classList.remove("nodrag");
      const { clientY: a } = c, s = e.draggedRect.bottom, S = Math.abs(a - s), k = e.dragged.querySelector(".tree-box").getAttribute("type"), z = e.dragged.querySelector(".tree-box").getAttribute("schemaId"), v = d(z);
      o.dragState.dragSchema = v;
      const D = e.related.querySelector(".tree-box").getAttribute("type"), H = e.related.querySelector(".tree-box").getAttribute("schemaId"), l = d(H);
      t.hoverVm = l;
      const b = (P = v == null ? void 0 : v.componentName) == null ? void 0 : P.container, Y = l == null ? void 0 : l.parent.schema.componentName;
      k === "col" && b && D !== "col" || k === "col" && !b && Y !== "row" || k !== "col" && b && D === "row" ? o.dragState.indicator = !1 : l ? o.dragState.indicator = !0 : o.dragState.indicator = !1, o.dragState.indicator ? (e.dragged.classList.remove("nodrag"), o.dragState.allowDrop = !0) : (e.dragged.classList.add("nodrag"), o.dragState.allowDrop = !1);
      const L = c.target;
      S < 4 && S > 1 && b && (!l.schema.children || l.schema.children.length === 0) && (o.dragState.parentNode = L, L.querySelector(".tiny-grid-tree-wrapper").innerHTML = '<i class="tiny-grid-tree__node-btn tiny-grid-icon__caret-right"></i>'), o.dragState.parentNode && o.dragState.parentNode.getAttribute("data-rowid") !== L.getAttribute("data-rowid") && (o.dragState.parentNode.querySelector(".tiny-grid-tree-wrapper").innerHTML = "", o.dragState.parentNode = null);
    };
    return q(
      () => t.isLock,
      (e) => {
        setTimeout(V, 1e3), o.isLock = e;
      }
    ), {
      panelFixed: T,
      checkElement: m,
      mouseover: _,
      mouseleave: w,
      showNode: C,
      state: o,
      getIcon: r,
      rowDropMove: U,
      gridRef: R,
      toggleTree: I,
      getClassName: B,
      PLUGIN_NAME: g,
      renderIconFn: (e, { isActive: c }) => e(ae(), {
        class: ["tiny-grid-tree__node-btn", { is__active: c }]
      })
    };
  }
}, me = { class: "tree-wrap lowcode-scrollbar" }, he = ["schemaId", "type", "onMouseover", "onMouseleave", "onClick"], fe = ["onMouseup"];
function ye(i, t, d, n, g, T) {
  const u = p("svg-button"), o = p("icon-eyeopen"), x = p("icon-eyeclose"), A = p("tiny-grid-column"), I = p("tiny-grid"), C = p("plugin-panel");
  return Q(), W(C, {
    class: "outlinebox",
    title: "大纲树",
    onClose: t[1] || (t[1] = (r) => i.$emit("close"))
  }, {
    header: N(() => [
      h(u, {
        class: "item icon-sidebar",
        name: n.panelFixed ? "fixed-solid" : "fixed",
        tips: n.panelFixed ? "解除固定面板" : "固定面板",
        onClick: t[0] || (t[0] = (r) => i.$emit("fix-panel", n.PLUGIN_NAME.OutlineTree))
      }, null, 8, ["name", "tips"])
    ]),
    content: N(() => [
      f("div", me, [
        h(I, {
          ref: "gridRef",
          data: n.state.pageSchema,
          "tree-config": { children: "children", expandAll: n.state.expandAll, renderIcon: n.renderIconFn },
          "show-header": !1,
          "highlight-hover-row": !1,
          "auto-resize": !0,
          "row-class-name": n.getClassName
        }, {
          default: N(() => [
            h(A, {
              field: "componentName",
              "tree-node": ""
            }, {
              default: N((r) => {
                var _, w;
                return [
                  f("span", {
                    class: "tree-box",
                    schemaId: (_ = r.row) == null ? void 0 : _.id,
                    type: r.row.componentName,
                    onMouseover: (m) => n.mouseover(r.row),
                    onMouseleave: (m) => n.mouseleave(r.row),
                    onClick: (m) => n.checkElement(r.row)
                  }, [
                    f("span", {
                      class: X(["tree-content", { "node-isblock": ((w = r.row) == null ? void 0 : w.componentType) === "Block" }])
                    }, [
                      f("span", null, Z(r.row.componentName), 1)
                    ], 2),
                    M(f("span", {
                      class: "tree-handle",
                      onMouseup: (m) => n.showNode(r.row)
                    }, [
                      M(h(o, null, null, 512), [
                        [E, r.row.show]
                      ]),
                      M(h(x, null, null, 512), [
                        [E, !r.row.show]
                      ])
                    ], 40, fe), [
                      [E, r.row.showEye]
                    ])
                  ], 40, he)
                ];
              }),
              _: 1
            })
          ]),
          _: 1
        }, 8, ["data", "tree-config", "row-class-name"])
      ])
    ]),
    _: 1
  });
}
const _e = /* @__PURE__ */ ge(ue, [["render", ye], ["__scopeId", "data-v-53344a08"]]), we = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  align: "top"
}, Me = {
  ...we,
  entry: _e
};
export {
  Me as default
};
